/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef TOPOLOGICALCONSTRAINT_HPP_
#define TOPOLOGICALCONSTRAINT_HPP_

#include "Settings.hpp"

namespace TreeTime_Constraint
{

	class TopologicalConstraint;
	ostream& operator<<(ostream&, const TopologicalConstraint&);

	class TopologicalConstraint
	{
		/**
		 * Declaration of friend ouput operator
		 */
		friend ostream& operator<<(ostream& , const TopologicalConstraint&);

		protected:

			const set<int>		m_sSpeciesId1;
			const set<int>		m_sSpeciesId2;

		public:

			TopologicalConstraint(const set<int>& p_Ids1,
					const set<int>& p_Ids2);
			virtual ~TopologicalConstraint();

			inline const set<int>& getSpeciesIds1() const;
			inline const set<int>& getSpeciesIds2() const;
			virtual inline bool isTimeConstraint() const;
			virtual double getLogDensity(double p_timepoint) const;

		private:

			TopologicalConstraint(const TopologicalConstraint&);
			TopologicalConstraint& operator = (const TopologicalConstraint&);

	};//TopologicalConstraint

}//TreeTime_Constraint

#include "TopologicalConstraint.cxx"

#endif /*TOPOLOGICALCONSTRAINT_HPP_*/
