/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef NODEDATA__HPP_
#define NODEDATA__HPP_

#include "Settings.hpp"
#include "../TreeTime_MolecularTree/NodeData.hpp"

namespace TreeTime_Core
{
	///NodeData is the Storage for the Tree Container.
	/**
	 * NodeData is the Storage for the Tree Container.
	 * All Attributes are public.
	 */
	struct NodeData : public TreeTime_MolecularTree::NodeData
	{

		virtual ~NodeData(){};

//		int							m_id;
//		double						m_length;
//		double						m_timepoint;

		/** Multiplier for the global Rate */
		double									m_globalRateMultiplier;
		/** Vector of Multipliers for the local Rate */
		vector<double>							m_vLocalRateMultiplier;
		/** Map to a List of Changepoints map<list<pair<double,double> > >,
		  * given as a Pair of Location and Value */
		map<int,list<pair<double,double> > >	m_mlChangepoints;
		/** Pointer to molecular Data */
		realf****								m_molecularData;
	};//NodeData

}//TreeTime_Core

#endif /*NODEDATA__HPP_*/
