/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CHANGEMEMINVSITES_HPP_
#define CHANGEMEMINVSITES_HPP_

#include "../../TreeTime_Mcmcmc/Change.hpp"
#include "../State.hpp"

namespace TreeTime_Core
{

	class ChangeMemInvSites : public TreeTime_Mcmcmc::Change
	{

		public:

			ChangeMemInvSites(State* p_pState, double p_proposalRatio,
					int p_modelNr);
			virtual ~ChangeMemInvSites();
			virtual void	changeState();
			virtual double	getStationaryDistributionRatio() const;
			virtual double	getProposalRatio() const;
			virtual void	accept();
			virtual void	reject();
			virtual int		getId () const;

		private:

			int				m_modelNr;
			State*			m_pState;
			double			m_proposalRatio;
			double			m_propOfInvSites;
			double			m_proposalTreeLogLikelihood;
	
	};//ChangeMemInvSites

}//TreeTime_Core

#endif /*CHANGEMEMINVSITES_HPP_*/
