/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MCMCMCDATA_HPP_
#define MCMCMCDATA_HPP_

namespace TreeTime_Mcmcmc
{

	class McmcmcData
	{

		public:

			virtual int		getNSamples() const = 0;
			virtual int		getBurnIn() const = 0;
			virtual int		getSampleFrequency() const = 0;
			virtual int		getNChains() const = 0;
			virtual double	getHeatingCoefficent() const = 0;
			virtual int		getSwapFrequency() const = 0;
			virtual ~McmcmcData(){};

	};

}//TreeTime_Mcmcmc

#endif /*MCMCMCDATA_HPP_*/
