/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace TreeTime_MolecularEvolution
{

	inline const double* const DnaEvolutionModel::getStationaryDistribution() const
	{
		return m_stationaryDistribution;
	}

	inline bool DnaEvolutionModel::hasGammaRates() const
	{
		return (m_nGammaRates>1);
	}

	inline int DnaEvolutionModel::getNGammaRates() const
	{
		return m_nGammaRates;
	}

	inline const double* const DnaEvolutionModel::getGammaRates() const
	{
		return m_rates;
	}

	inline double DnaEvolutionModel::getGammaShapeParameter() const
	{
		return m_gammaShapeParameter;
	}

	inline bool DnaEvolutionModel::hasInvariantSites() const
	{
		return m_hasInvariantSites;
	}

	inline double DnaEvolutionModel::getProportionOfInvariantSites() const
	{
		return m_proportionOfInvariantSites;
	}

	inline void DnaEvolutionModel::setProportionOfInvariantSites(double p_propInvSites)
	{
		m_proportionOfInvariantSites = p_propInvSites;
	}

	inline int DnaEvolutionModel::getNIndependentStatDistrParameters() const
	{
		return m_nIndependentStatDistrParameters;
	}	

	inline int DnaEvolutionModel::getNIndependentTransModelParameters() const
	{
		return m_nIndependentTransModelParameters;
	}

	inline void DnaEvolutionModel::setRandom(Random* p_pRandom)
	{
		s_pRandom = p_pRandom;
	}

}//MolcularEvolution

