/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace TreeTime_MolecularTree
{
	template<class NODEDATA>
	BinaryNode<NODEDATA>::BinaryNode()
	: m_pFather(0)
	, m_pRightSon(0)
	, m_pLeftSon(0)
	, m_NodeData()
	{
		m_NodeData.m_id = -1;
	}

	template<class NODEDATA>
	BinaryNode<NODEDATA>::BinaryNode(const BinaryNode<NODEDATA>& p_BinaryNode)
	: m_pFather  (0)
	, m_pRightSon(0)
	, m_pLeftSon (0)
	, m_NodeData (p_BinaryNode.m_NodeData)
	{
	}

	template<class NODEDATA>
	BinaryNode<NODEDATA>::BinaryNode(const NODEDATA& p_NodeData)
	: m_pFather  (0)
	, m_pRightSon(0)
	, m_pLeftSon (0)
	, m_NodeData (p_NodeData)
	{
	}

	template<class NODEDATA>
	BinaryNode<NODEDATA>& BinaryNode<NODEDATA>::operator=(const BinaryNode<NODEDATA>& p_BinaryNode)
	{
		m_pFather   = 0;
		m_pRightSon = 0;
		m_pLeftSon  = 0;
		m_NodeData  = p_BinaryNode.m_NodeData;
		return *this;
	}

	template<class NODEDATA>
	BinaryNode<NODEDATA>::~BinaryNode()
	{
	}

	template<class NODEDATA>
	inline BinaryNode<NODEDATA>* BinaryNode<NODEDATA>::getFather() const
	{
		return m_pFather;
	}

	template<class NODEDATA>
	inline BinaryNode<NODEDATA>* BinaryNode<NODEDATA>::getRightSon() const
	{
		return m_pRightSon;
	}

	template<class NODEDATA>
	inline BinaryNode<NODEDATA>* BinaryNode<NODEDATA>::getLeftSon() const
	{
		return m_pLeftSon;
	}

	template<class NODEDATA>
	inline void BinaryNode<NODEDATA>::setFather(BinaryNode* p_pNewFather)
	{
		m_pFather = p_pNewFather;
	}

	template<class NODEDATA>
	inline void BinaryNode<NODEDATA>::setRightSon(BinaryNode* p_pNewRightSon)
	{
		m_pRightSon = p_pNewRightSon;
	}

	template<class NODEDATA>
	inline void BinaryNode<NODEDATA>::setLeftSon(BinaryNode* p_pNewLeftSon)
	{
		m_pLeftSon = p_pNewLeftSon;
	}

	template<class NODEDATA>
	inline NODEDATA& BinaryNode<NODEDATA>::getNodeData()
	{
		return m_NodeData;
	}

}//TreeTime_MolecularTree
