/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef NODEDATA_HPP_
#define NODEDATA_HPP_

#include "Settings.hpp"

namespace TreeTime_MolecularTree
{
	///NodeData is the Storage for the Tree Container.
	/**
	 * NodeData is the Storage for the Tree Container.
	 * All Attributes are public.
	 */
	struct NodeData
	{
		virtual ~NodeData(){};
		/** Unique id representing a Species */
		int							m_id;
		/** Length of the Branch, with direction to the Father Node */
		double						m_length;
		/** Timepoint of the Node */
		double						m_timepoint;
//		/** List of Changepoints, given as a Pair of Location and Value */
//		list<pair<double,double> >	m_lChangepoints;
//		/** Pointer to molecular Data */
//		realf****					m_molecularData;
	};//NodeData

}//TreeTime_MolecularTree

#endif /*NODEDATA_HPP_*/
