/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace TreeTime_NexusProcessing
{
	inline int Data::getSeed() const
	{
		return m_randomSeed;
	}
	inline void Data::setSeed(int p_seed)
	{
		m_randomSeed = p_seed;
	}
	inline bool Data::getRateChanges() const
	{
		return m_withRateChanges;
	}
	inline void Data::setRateChanges(bool p_rateChanges)
	{
		m_withRateChanges = p_rateChanges;
	}
	inline bool Data::getMemChanges() const
	{
		return m_withMemChanges;
	}
	inline void Data::setMemChanges(bool p_memChanges)
	{
		m_withMemChanges = p_memChanges;
	}
	inline string Data::getOutputPath() const
	{
		return m_outputPath;
	}
	inline void Data::setOutputPath(string p_outputPath)
	{
		m_outputPath = p_outputPath;
	}
	inline void Data::setBurnIn(int _burnIn)
	{
		m_burnIn = _burnIn;
	}
	inline void Data::setSampleFrequency(int _sampleFrequency)
	{
		m_sampleFrequency = _sampleFrequency;
	}
	inline void Data::setNSamples(int _nSamples)
	{
		m_nSamples = _nSamples;
	}
	inline void Data::setNChains(int _nChains)
	{
		m_nChains = _nChains;
	}
	inline int Data::getNChar() const
	{
		return m_nChar;
	}
	inline void Data::setNChar(int _nChar)
	{
		m_nChar = _nChar;
	}
	inline int Data::getNTaxa() const
	{
		return m_nTaxa;
	}
	inline void Data::setNTaxa(int _nTaxa)
	{
		m_nTaxa = _nTaxa;
	}
	inline map<string,int>& Data::getSpecies2Id()
	{
		return m_mSpeciesToId;
	}
	inline map<int,string>& Data::getId2Species()
	{
		return m_mIdToSpecies;
	}
	inline void Data::setActiveSpecies(vector<int> _active)
	{
		m_vActiveSpeciesId = _active;
	}
	inline map<int,string>& Data::getDna()
	{
		return m_mIdToDna;
	}
	inline int Data::getOutgroup() const
	{
		return m_outgroup;
	}
	inline void Data::setOutgroup(int _outgroup)
	{
		m_outgroup = _outgroup;
	}
	inline void Data::setMissing(char _missing)
	{
		m_missing = _missing;
	}
	inline char Data::getMissing()
	{
		return m_missing;
	}
	inline void Data::setGap(char _gap)
	{
		m_gap = _gap;
	}
	inline char Data::getGap()
	{
		return m_gap;
	}
	inline void Data::setPurin(char _purin)
	{
		m_purin = _purin;
	}
	inline char Data::getPurin()
	{
		return m_purin;
	}
	inline void Data::setPyrimidin(char _pyrimidin)
	{
		m_pyrimidin = _pyrimidin;
	}
	inline char Data::getPyrimidin()
	{
		return m_pyrimidin;
	}
	inline void	Data::setMatching(char _matching)
	{
		m_matching = _matching;
	}
	inline string& Data::getInitialTree()
	{
		return m_initialTree;
	}
	inline void Data::setInitialTree(string _initialTree)
	{
		m_initialTree = _initialTree;
	}
	inline vector<int>& Data::getBeginningFragments()
	{
		return m_vBeginningFragments;
	}
	inline vector<TreeTime_MolecularEvolution::DnaEvolutionModel*>& Data::getInitialMolecularModels()
	{
		return m_vpInitialDnaModels;
	}
	inline vector<string>&	Data::getInitialRateChangeModels()
	{
		return m_vInitialRateChangeModels;
	}
	inline string& Data::getInitialGlobalRateChangeModel()
	{
		return m_InitialGlobalRateChangeModel;
	}
	inline vector<TreeTime_Constraint::TopologicalConstraint*>& Data::getConstraints()
	{
		return m_vpConstraints;
	}
	inline vector<TreeTime_Constraint::TopologicalConstraint*>& Data::getTopologicalConstraints()
	{
		return m_vpTopConstraints;
	}
	inline vector<TreeTime_Constraint::GaussianConstraint*>& Data::getGaussianConstraints()
	{
		return m_vpGauConstraints;
	}
	inline vector<TreeTime_Constraint::GammaConstraint*>& Data::getGammaConstraints()
	{
		return m_vpGamConstraints;
	}
	
	inline map<int,vector4d>& Data::getId2DnaData()
	{
		return m_mIdToCompressedDna;
	}
	inline vector<vector<int> >& Data::getDnaMultipliers()
	{
		return m_vvDnaMultipliers;
	}
	inline vector<int>& Data::getBeginningAndEndLoci()
	{
		return m_vBeginningAndEndLoci;
	}
	inline vector<int>& Data::getRateDimensions()
	{
		return m_vRateDimensions;
	}
	inline vector<vector<vector<int> > >& Data::getInvariantNucleotides()
	{
		return m_vvvInvariantNucleotides;
	}
	inline void Data::setHeatingCoefficent(double p_heatingCoefficient)
	{
		m_heatingCoefficient = p_heatingCoefficient;
	}
	inline double Data::getWeightTopology() const
	{
		return m_weightTopology;
	}
	inline double Data::getWeightNodes() const
	{
		return m_weightNodes;
	}
	inline double Data::getWeightEvolution() const
	{
		return m_weightEvolution;
	}
	inline double Data::getWeightRatechange() const
	{
		return m_weightRatechange;
	}
	inline double Data::getWeightTimeconversion() const
	{
		return m_weightTimeconversion;
	}
	inline void Data::setWeightTopology(double p_weightTopology)
	{
		m_weightTopology = p_weightTopology;
	}
	inline void Data::setWeightNodes(double p_weightNodes)
	{
		m_weightNodes = p_weightNodes;
	}
	inline void Data::setWeightEvolution(double p_weightEvolution)
	{
		m_weightEvolution = p_weightEvolution;
	}
	inline void Data::setWeightRatechange(double p_weightRatechange)
	{
		m_weightRatechange = p_weightRatechange;
	}
	inline void Data::setWeightTimeconversion(double p_weightTimeconversion)
	{
		m_weightTimeconversion = p_weightTimeconversion;
	}
	inline void Data::setNodeTime(double p_)
	{
		m_cNodeTime = p_;
	}
	inline void Data::setTimeSynchronisation(double p_)
	{
		m_cTimeSynchronisation = p_;
	}
	inline void Data::setRootTime(double p_)
	{
		m_cRootTime = p_;
	}
	inline double Data::getNodeTime()
	{
		return m_cNodeTime;
	}
	inline double Data::getTimeSynchronisation()
	{
		return m_cTimeSynchronisation;
	}
	inline double Data::getRootTime()
	{
		return m_cRootTime;
	}
	
}//TreeTime_NexusProcessing
