/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef NEXUSPARSER_HPP_
#define NEXUSPARSER_HPP_

#include "Settings.hpp"

namespace TreeTime_NexusProcessing
{

	class Data;

	class NexusParser
	{
		private:

			Data* CurrentData;

		public:

			NexusParser(Data* CurrentData_);
			void parseNexusFile(string& nexusfile);

		private:

			int positionOfOpeningBracket(string&);
			int positionOfClosingBracket(string&);
			int positionOfBracket(string&);
			void strToUpperCase(string& str);
			void processNexusDataBlock(std::stringstream&);
			void processNexusTreeTimeBlock(std::stringstream&);
	};

}//TreeTime_NexusProcessing

#endif /*NEXUSPARSER_HPP_*/
