/*
Copyright (C) 2006-2008 Lin Himmelmann

This file is part of TreeTime.
See the NOTICE file distributed with this work for additional
information regarding copyright ownership and licensing.

TreeTime is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TreeTime is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TreeTime.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef TT_RCM_SETTINGS_HPP_
#define TT_RCM_SETTINGS_HPP_

// ---------------- 
// --- Librarys ---
// ----------------
#include <string>
#include <iomanip>
#include <list>
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <valarray>
#include <iterator>
#include <memory>
#include <limits>
#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdlib>
#include <cmath>

// -------------- 
// --- usings ---
// --------------
using std::string;
using std::stringstream;
using std::vector;
using std::list;
using std::stack;
using std::map;
using std::set;
using std::multiset;
using std::valarray;
using std::cout;
using std::cin;
using std::endl;
using std::ostream;
using std::ofstream;
using std::pair;

// ---------------- 
// --- typedefs ---
// ----------------
typedef float								realf;
typedef vector<vector<double> >				vector2d;
typedef vector<vector<vector<double> > >	vector3d;
typedef unsigned int						unint;
typedef double								real;

// ---------------- 
// --- Namespace --
// ----------------
//namespace _linhi_{}
//using namespace _linhi_;
//namespace TreeTime_MolecularTree{}
//using namespace TreeTime_MolecularTree;
//namespace TreeTime_Core{}
//using namespace TreeTime_Core;
//namespace TreeTime_Mcmcmc{}
//using namespace TreeTime_Mcmcmc;
//namespace TreeTime_MolecularEvolution{}
//using namespace TreeTime_MolecularEvolution;
//namespace TreeTime_NexusProcessing{}
//using namespace TreeTime_NexusProcessing;

#endif /*TT_RCM_SETTINGS_HPP_*/
